unit compar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, ComCtrls, Menus,FileCtrl;

type
  TForm1 = class(TForm)
    DirectoryEdit1: TDirectoryEdit;
    DirectoryEdit2: TDirectoryEdit;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TRichEdit;
    Sousrep: TCheckBox;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Copier1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    Imprimer1: TMenuItem;
    Apropos1: TMenuItem;
    GroupBox1: TGroupBox;
    RB1: TRadioButton;
    RB2: TRadioButton;
    FilenameEdit1: TFilenameEdit;
    FilenameEdit2: TFilenameEdit;
    Slectionnertout1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure Imprimer1Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure RB2Click(Sender: TObject);
    procedure RB1Click(Sender: TObject);
    procedure DirectoryEdit1BeforeDialog(Sender: TObject; var Name: String;
      var Action: Boolean);
    procedure DirectoryEdit2BeforeDialog(Sender: TObject; var Name: String;
      var Action: Boolean);
    procedure Fichier1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Slectionnertout1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

uses Result;

{$R *.DFM}
var rec,recu:TSearchRec;
    Nbcomp,NbId,NbDif,NbPas:integer;

function comparer(nom,nom2:string):boolean;
{This function performs file comparison. File named nom is compared to file
 named nom2- Returns True if files are identical.}
var f,g:file;
    NumRead, NumRead2: Integer;
    Buf,Buf2: array[1..2048] of Char;
    i:longint;
    flag:boolean;

begin
 if (copy(nom,length(nom),1)='.') or (copy(nom,length(nom)-1,2)='..') then begin
  Comparer:=true;
  exit;
 end;
 Assignfile(f,nom);
 Assignfile(g,nom2);
 Reset(g,1);
 Reset(f,1);
 flag:=true;
 repeat
  BlockRead(f, Buf, SizeOf(Buf), NumRead);
  BlockRead(g, Buf2, NumRead, NumRead2);
  for i :=1 to NumRead do begin
   if buf[i]<>buf2[i] then begin
    flag:=false;
    break;
   end;
  end;
 Until (numread=0) or (flag=false) or (numread2=0);
 Comparer:=flag;
 CloseFile(f);
 CloseFile(g);
end;

procedure TForm1.Button1Click(Sender: TObject);
{ix is the index - Liste is the stringlist}
var ix:integer;
    Liste:Tstringlist;

procedure fiche;
{This procedure handles simple files comparison.}

begin
 {First removes "" from long filenames}
 if FileNameEdit1.Text[1]='"' then FileNameEdit1.Text:=Copy(FileNameEdit1.Text,
                                   2,length(FilenameEdit1.Text)-2);
 if FileNameEdit2.Text[1]='"' then FileNameEdit2.Text:=Copy(FileNameEdit2.Text,
                                   2,length(FilenameEdit2.Text)-2);
 {Then performs comparison, unless one or both files do not exist}
 if Fileexists(FileNameEdit1.Text) and FileExists(FilenameEdit2.Text) then
   if comparer(FilenameEdit1.Text,FileNameEdit2.text) then
    Application.messageBox('Files are identical.','Finished',mb_OK)
   else
    Application.MessageBox('Files are different.','Finished',mb_OK)
 else
   Application.MessageBox('At least one file doesn''t exist or was not specified!','Caution',
                           mb_Ok);
end;

procedure recurs(dir:string;lon:integer);
var rec:TsearchRec;
    diro,res:string;

begin
 {Recursively search for sub directories}
 if findfirst(dir,16,rec)=0 then begin
  while findnext(rec)=0 do
   {Skips the root directories "." and ".."}
   if ((rec.attr and 16)>0) and (rec.name<>'.') and (rec.name<>'..') then begin
     res:=copy(dir,1,length(dir)-3)+rec.name;
     {Subdirectories names are stored in the stringlist}
     Liste.Add(copy(res,lon,length(res)-lon+1));
     diro:=copy (dir,1,length(dir)-3)+rec.name+'\*.*';
     recurs(diro,lon);
   end;
  findclose(rec);
 end;
end;

begin
 filemode:=0; {Subsequent Reset will operate in Read only mode}
 {If checkbox unchecked, performs simple files comparison}
 if rb2.checked then begin fiche;exit;end;

 if (directoryEdit1.text='') or (DirectoryEdit2.text='') then begin
  Application.Messagebox('You did''nt specify one of the directories!','Caution',
  MB_OK);
  exit;
 end;
 NbComp:=0;NbDif:=0;NbId:=0;NbPas:=0;

Try
 {Instantiate string list}
 Liste:=TStringList.Create;
 Liste.Add('');{For root directory}
 Memo1.Lines.Clear;
 Button1.Enabled:=False;Screen.Cursor:=CrHourGlass;

 {Truncate "C:\" to "C:"}
 if length(DirectoryEdit2.Text)=3 then DirectoryEdit2.Text:=Copy(DirectoryEdit2.Text,1,2);
 if length(DirectoryEdit1.Text)=3 then DirectoryEdit1.Text:=Copy(DirectoryEdit1.Text,1,2);

 if sousrep.checked then
 {Recurse if checkbox checked}
  recurs(DirectoryEdit1.Text+'\*.*',length(DirectoryEdit1.Text+'\'));

 for ix:=0 to Liste.Count -1 do begin
  {Performs comparison for all subdirectories}
  if (Liste.Strings[ix]<>'') or (ix=0) then begin

   Memo1.SelAttributes.Color:=ClBlue;Memo1.Selattributes.Style:=[fsBold,fsUnderline];
   Memo1.Lines.Add('Comparing files in directory:'+DirectoryEdit1.Text
                   +Liste.Strings[ix]);
   Memo1.SelAttributes.Color:=ClBlack;Memo1.Selattributes.Style:=[];
   Memo1.Lines.Add('');

   if findfirst(DirectoryEdit1.Text+Liste.Strings[ix]+'\*.*',39,Rec)=0 then
    Memo1.Lines.Add(rec.name)
   else
    Memo1.Lines.Add('No files found in "'+DirectoryEdit1.Text+Liste.Strings[ix]+'"');

   if (findfirst(DirectoryEdit2.Text+Liste.Strings[ix],16,recu)<>0)
      and (Liste.Strings[ix]<>'') then begin
    Memo1.SelAttributes.Style:=[fsBold];Memo1.Selattributes.Color:=ClPurple;Inc(NbPas);
    Memo1.Lines.Add('Not such a subdirectory:"'+Liste.Strings[ix]+'" in target!');
    Memo1.SelAttributes.Style:=[];Memo1.SelAttributes.color:=ClBlack;
    FindClose(recu);
    Memo1.Lines.Add('');
    continue;
   end
   else
    findclose(recu);

   if findfirst(DirectoryEdit2.text+Liste.Strings[ix]+'\'+rec.name,39,recu)=0 then
   {Performs comparison}
    if comparer(DirectoryEdit1.Text+Liste.Strings[ix]+'\'+rec.name,DirectoryEdit2.Text
       +Liste.Strings[ix]+'\'+recu.name) then begin
     Memo1.selattributes.Style:=[fsBold];
     Memo1.Selattributes.color:=ClGreen;Memo1.Lines.Add('Identical');Inc(NbComp);
     Inc(NbId);
     Memo1.SelAttributes.Color:=ClBlack;Memo1.SelAttributes.Style:=[]end
    else begin
     Memo1.SelAttributes.Style:=[fsBold];Memo1.Selattributes.Color:=ClRed;
     Memo1.Lines.Add('---------->Different');Memo1.SelAttributes.Style:=[];Inc(NbComp);
     Inc(NbDif);
     Memo1.SelAttributes.color:=ClBlack;end

   else begin

    Memo1.SelAttributes.Color:=ClBlue;
    Memo1.Lines.Add('Not found in: '+DirectoryEdit2.Text+Liste.Strings[ix]);
    Memo1.SelAttributes.Color:=ClBlack;
   end;

   while findnext(Rec)=0 do begin
    findclose(recu);
    Memo1.Lines.Add(rec.name);
    if findfirst(DirectoryEdit2.text+Liste.Strings[ix]+'\'+rec.name,39,recu)=0 then

     if comparer(DirectoryEdit1.Text+Liste.Strings[ix]+'\'+rec.name,DirectoryEdit2.Text
                 +Liste.Strings[ix]+'\'+recu.name) then begin
      Memo1.SelAttributes.Style:=[fsBold];
      Memo1.Selattributes.color:=ClGreen;Memo1.Lines.Add('Identical');Inc(NbComp);
      Inc(NbId);
      Memo1.SelAttributes.Color:=ClBlack;Memo1.selAttributes.Style:=[];end
     else begin
      Memo1.SelAttributes.Style:=[fsBold];Memo1.Selattributes.Color:=ClRed;
      Memo1.Lines.Add('---------->Different');Memo1.SelAttributes.Style:=[];Inc(NbComp);
      Inc(NbDif);
      Memo1.SelAttributes.color:=ClBlack;end

    else begin

     Memo1.SelAttributes.Color:=ClBlue;
     Memo1.Lines.Add('Not found in: '+DirectoryEdit2.Text+Liste.Strings[ix]);
     Memo1.SelAttributes.Color:=ClBlack;
    end;
   end;
   findclose(Rec);
  end
  else
   break;
   Memo1.Lines.Add('');
 end;
Finally
 Button1.Enabled:=True;Screen.Cursor:=CrDefault;
 {Finally free the string list}
 Liste.Free;
End;
 Resul.Label4.Caption:=IntToStr(NbComp);
 Resul.Label5.Caption:=InttoStr(NbDif);
 Resul.Label6.Caption:=Inttostr(NbId);
 Resul.Label8.Caption:=IntToStr(NbPas);
 Resul.Showmodal;
 Resul.Close
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.Copier1Click(Sender: TObject);
begin
 Memo1.CopyToClipBoard;
end;

procedure TForm1.Imprimer1Click(Sender: TObject);
begin
 Memo1.Print('');
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin
 Application.MessageBox('Files and folders Compare - By Marc SAAL (2000) - Version 1.0',
                        'About this program',mb_OK);
end;

procedure TForm1.RB2Click(Sender: TObject);
begin
 FileNameEdit1.Visible:=True;
 FileNameEdit2.Visible:=True;
 DirectoryEDit1.Visible:=False;
 DirectoryEdit2.Visible:=False;
 SousRep.Enabled:=False;
end;

procedure TForm1.RB1Click(Sender: TObject);
begin
 FileNameEdit1.Visible:=False;
 FileNameEdit2.Visible:=False;
 DirectoryEDit1.Visible:=True;
 DirectoryEdit2.Visible:=True;
 Sousrep.Enabled:=True;
end;

procedure TForm1.DirectoryEdit1BeforeDialog(Sender: TObject;
  var Name: String; var Action: Boolean);
begin
 if not DirectoryExists(DirectoryEdit1.Text) and (DirectoryEdit1.InitialDir<>'') then
   ChDir('C:\');
end;

procedure TForm1.DirectoryEdit2BeforeDialog(Sender: TObject;
  var Name: String; var Action: Boolean);
begin
 if not DirectoryExists(DirectoryEdit2.Text) and (DirectoryEdit2.InitialDir<>'') then
   ChDir('C:\');
end;

procedure TForm1.Fichier1Click(Sender: TObject);
begin
 if Memo1.SelLength=0 then begin
  Copier1.Enabled:=False;
  Imprimer1.Enabled:=False;
 end
 else begin
  Copier1.Enabled:=True;
  Imprimer1.Enabled:=True;
 end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 FileNameEdit1.ButtonHint:='Click this button to select';
 FileNameEdit2.ButtonHint:=FileNameEdit1.ButtonHint;
 DirectoryEdit1.ButtonHint:=FileNameEdit1.ButtonHint;
 DirectoryEdit2.ButtonHint:=FileNameEdit1.ButtonHint;
end;

procedure TForm1.Slectionnertout1Click(Sender: TObject);
begin
 Memo1.SelectAll;
end;

end.


